"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const GestureHandler = _ref => {
  let {
    onEndTouchEvents,
    onStartTouchEvents,
    onChangeTouchEvents
  } = _ref;
  const pathRef = (0, _react.useRef)([]);

  const panResponder = _reactNative.PanResponder.create({
    onStartShouldSetPanResponder: () => true,
    onStartShouldSetPanResponderCapture: () => true,
    onMoveShouldSetPanResponder: () => true,
    onMoveShouldSetPanResponderCapture: () => true,
    onPanResponderGrant: (e, gestureState) => {
      pathRef.current = [];
      onStartTouchEvents === null || onStartTouchEvents === void 0 ? void 0 : onStartTouchEvents(e, gestureState);
    },
    onPanResponderMove: event => {
      pathRef.current.push({
        x: event.nativeEvent.locationX,
        y: event.nativeEvent.locationY
      });
      onChangeTouchEvents === null || onChangeTouchEvents === void 0 ? void 0 : onChangeTouchEvents([...pathRef.current]);
    },
    onPanResponderRelease: () => {
      const points = [...pathRef.current];
      onChangeTouchEvents(points);
      onEndTouchEvents === null || onEndTouchEvents === void 0 ? void 0 : onEndTouchEvents(points);
    }
  });

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({
    style: {
      backgroundColor: 'transparent',
      position: 'absolute',
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    }
  }, panResponder.panHandlers));
};

var _default = GestureHandler;
exports.default = _default;
//# sourceMappingURL=gesture-responder.js.map