"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeMaps = _interopRequireDefault(require("react-native-maps"));

var _reactNative = require("react-native");

var _core = require("../core");

var _contstant = require("./contstant");

var _GEO = _interopRequireWildcard(require("geolib"));

var _useValidator = _interopRequireDefault(require("../hooks/use-validator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  (0, _useValidator.default)(props);
  const {
    points,
    children,
    colorLine = _contstant.DEFAULT_ACTIVE_COLOR_LINE,
    widthLine = _contstant.DEFAULT_ACTIVE_COLOR_LINE_WIDTH,
    onEndDraw,
    isDrawMode = _contstant.DEFAULT_DRAW_MODE,
    // renderPath,
    onStartDraw,
    unitDistance = _contstant.DEFAULT_UNIT_DISTANCE,
    configuration,
    onChangePoints,
    fillColorCanvas = _contstant.DEFAULT_FILL_BACKGROUND_CANVAS,
    styleViewGesture,
    backgroundCanvas = _contstant.DEFAULT_BACKGROUND_VIEW_CANVAS,
    ...rest
  } = props;
  const internalRef = (0, _react.useRef)(null);
  const mapRef = ref || internalRef;
  const {
    width,
    height
  } = (0, _reactNative.useWindowDimensions)();
  const [containerSize, setContainerSize] = (0, _react.useState)({
    width,
    height
  });
  const {
    type
  } = configuration;
  const containerStyle = (0, _react.useMemo)(() => [{
    zIndex: 1,
    backgroundColor: backgroundCanvas
  }, _reactNative.StyleSheet.absoluteFill, styleViewGesture], [backgroundCanvas, styleViewGesture]);
  const path = (0, _react.useMemo)(() => points.map(item => `${item.x},${item.y}`).join(' '), [points]);

  const calculatedCenterPolygon = coordinates => Promise.resolve(_GEO.getCenter(coordinates));

  const convertPointToCoordinates = (0, _react.useCallback)(polygons => {
    if (polygons && polygons.length > 0) {
      calculatedCenterPolygon(polygons).then(centerLatLng => {
        if (onEndDraw && centerLatLng) {
          const distance = _GEO.convertDistance(_GEO.getPathLength(polygons), unitDistance);

          const initialLatLng = polygons[_contstant.DEFAULT_INDEX_INITIAL_LAT_LNG];
          const lastLatLng = polygons[polygons.length - 1];
          onEndDraw({
            polygons,
            distance,
            centerLatLng,
            initialLatLng,
            lastLatLng
          });
        }
      });
    }
  }, [onEndDraw, unitDistance]);
  const convertByPoint = (0, _react.useCallback)(async item => {
    var _mapRef$current;

    return await ((_mapRef$current = mapRef.current) === null || _mapRef$current === void 0 ? void 0 : _mapRef$current.coordinateForPoint(item));
  }, [mapRef]);
  const handleEndDraw = (0, _react.useCallback)(async data => {
    await Promise.all(data.map(convertByPoint)).then(convertPointToCoordinates);
  }, [convertByPoint, convertPointToCoordinates]);
  const handleSetContainerSize = (0, _react.useCallback)(event => {
    setContainerSize({
      width: event.nativeEvent.layout.width,
      height: event.nativeEvent.layout.height
    });
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNativeMaps.default, _extends({
    scrollEnabled: !isDrawMode,
    ref: mapRef
  }, rest), children), isDrawMode ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: containerStyle,
    onLayout: handleSetContainerSize
  }, type === 'draw' && /*#__PURE__*/_react.default.createElement(_core.DrawControl, {
    path: path,
    widthLine: widthLine,
    colorLine: colorLine,
    containerSize: containerSize,
    fillColorCanvas: fillColorCanvas,
    onEndTouchEvents: handleEndDraw,
    onStartTouchEvents: onStartDraw,
    onChangeTouchEvents: onChangePoints
  })) : null);
});

exports.default = _default;
//# sourceMappingURL=maps.js.map