"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

var _reactNativeSvg = require("react-native-svg");

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const MapPolygon = _ref => {
  let {
    path,
    fillOverlay,
    widthOverlayLine,
    colorWidthOverlayLine,
    backgroundOverlayPolygon
  } = _ref;
  const {
    width,
    height
  } = (0, _reactNative.useWindowDimensions)();
  return /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Svg, {
    height: height,
    width: width,
    viewBox: `0 0 ${width} ${height}`,
    style: [styles.container, {
      backgroundColor: backgroundOverlayPolygon
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Defs, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Mask, {
    id: "mask",
    x: "0",
    y: "0",
    height: "100%",
    width: "100%"
  }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
    height: "100%",
    width: "100%",
    fill: "#fff"
  }), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Polygon, {
    points: path,
    fill: fillOverlay,
    stroke: colorWidthOverlayLine,
    strokeWidth: widthOverlayLine
  }))), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
    height: "100%",
    width: "100%",
    fill: "rgba(0, 0, 0, 0.7)",
    mask: "url(#mask)",
    "fill-opacity": "0"
  }));
};

var _default = MapPolygon;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    position: 'absolute',
    zIndex: 4
  }
});
//# sourceMappingURL=polygon.js.map