function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useRef } from 'react';
import { PanResponder, View } from 'react-native';

const GesturePointersHandler = _ref => {
  let {
    onEndTouchEvents,
    onStartTouchEvents
  } = _ref;
  const pathRef = useRef([]);
  const panResponder = PanResponder.create({
    onStartShouldSetPanResponder: () => true,
    onStartShouldSetPanResponderCapture: (event, gestureState) => {
      pathRef.current.push({
        x: event.nativeEvent.locationX,
        y: event.nativeEvent.locationY
      });
      onStartTouchEvents === null || onStartTouchEvents === void 0 ? void 0 : onStartTouchEvents(event, gestureState);
      return true;
    },
    onMoveShouldSetPanResponder: () => false,
    onMoveShouldSetPanResponderCapture: () => false,
    onPanResponderGrant: () => false,
    onPanResponderMove: () => {},
    onPanResponderRelease: event => {
      pathRef.current.push({
        x: event.nativeEvent.locationX,
        y: event.nativeEvent.locationY
      });
      onEndTouchEvents === null || onEndTouchEvents === void 0 ? void 0 : onEndTouchEvents(pathRef.current);
    }
  });
  return /*#__PURE__*/React.createElement(View, _extends({
    style: {
      backgroundColor: 'transparent',
      position: 'absolute',
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    }
  }, panResponder.panHandlers));
};

export default GesturePointersHandler;
//# sourceMappingURL=gesture-responder.js.map