import { useWindowDimensions, StyleSheet } from 'react-native';
import { Svg, Defs, Rect, Mask, Polygon } from 'react-native-svg';
import React from 'react';

const MapPolygon = _ref => {
  let {
    path,
    fillOverlay,
    widthOverlayLine,
    colorWidthOverlayLine,
    backgroundOverlayPolygon
  } = _ref;
  const {
    width,
    height
  } = useWindowDimensions();
  return /*#__PURE__*/React.createElement(Svg, {
    height: height,
    width: width,
    viewBox: `0 0 ${width} ${height}`,
    style: [styles.container, {
      backgroundColor: backgroundOverlayPolygon
    }]
  }, /*#__PURE__*/React.createElement(Defs, null, /*#__PURE__*/React.createElement(Mask, {
    id: "mask",
    x: "0",
    y: "0",
    height: "100%",
    width: "100%"
  }, /*#__PURE__*/React.createElement(Rect, {
    height: "100%",
    width: "100%",
    fill: "#fff"
  }), /*#__PURE__*/React.createElement(Polygon, {
    points: path,
    fill: fillOverlay,
    stroke: colorWidthOverlayLine,
    strokeWidth: widthOverlayLine
  }))), /*#__PURE__*/React.createElement(Rect, {
    height: "100%",
    width: "100%",
    fill: "rgba(0, 0, 0, 0.7)",
    mask: "url(#mask)",
    "fill-opacity": "0"
  }));
};

export default MapPolygon;
const styles = StyleSheet.create({
  container: {
    position: 'absolute',
    zIndex: 4
  }
});
//# sourceMappingURL=polygon.js.map